
/*
 * dummy_video.c 
 */

#include <stdio.h>
#include <fcntl.h>
#include <sys/time.h>


#include "sentry.h"

#include <errno.h>

extern  int     frameSize;
extern  int     xsize, ysize;

extern  int     verb;

#define Dummy_Size   76800
#define Dummy_X      160
#define Dummy_Y      120
char DummyFrame[Dummy_Size];

#define SAMPLE_JPEG_PATH        "../dummy/photos"
#define MAX_SAMPLE_JPEG         7
#define MAX_IMAGE_SIZE          (10*1024)  /* 10 KB */

struct {
  int  image_size;
  char image_buff[MAX_IMAGE_SIZE];
} image_info[MAX_SAMPLE_JPEG];

static int ImageNumber;

void
init_video(char *vserver)
{
  int i;
  char filename[128];
  int fd;
  char *ptr;
  int nread;
  

  for(i=0; i<MAX_SAMPLE_JPEG; i++) {
    sprintf(filename, "%s/sample%d.jpg", SAMPLE_JPEG_PATH, i);
    if ( (fd = open(filename, O_RDONLY)) < 0) {
      fprintf(stderr, "init_video: cannot open %s:", filename);
      perror("open");
      exit (1);
    }

    xsize = 120;
    ysize = 90;
    image_info[i].image_size = 0;
    bzero(image_info[i].image_buff, MAX_IMAGE_SIZE);
    ptr = image_info[i].image_buff;

    while (1) {
      nread = read(fd, ptr, 16384);
      if (nread < 0) {
	if (errno == EINTR) continue;
	else  exit (1);
      }
      image_info[i].image_size += nread;
      ptr = &ptr[nread];

      if (nread < 16384 || nread == 0) break;
    }

#if 0
    if (debug) {
      char save_filename[128];
      fprintf(stderr, "image[%d].size# %d\n", i, image[i].size);
      
      sprintf(save_filename, "%s/debug-sample%d.jpg", SAMPLE_JPEG_PATH, i);
      if ( (fd = open(save_filename, O_WRONLY, 0644)) < 0) {
	fpritnf(stderr, "init_video: debug: cannot open %s:", save_filename);
	perror("open");
	next;
      }
    }
#endif 

  } /* for-loop */
}

int 
check_video(char *vserver)
{
  return 0;
}


char *
capture_frame()
{
  frameSize = image_info[ImageNumber].image_size;
  return image_info[ImageNumber].image_buff;
}

int
release_frame()
{
  static int c=0;

  c = 1 - c;
  if (c==0) return 0;

  if (++ImageNumber >= MAX_SAMPLE_JPEG)
    ImageNumber -= MAX_SAMPLE_JPEG;

  if (verb) {
    fprintf(stderr, "release_frame: ImageNumber# %d\n", ImageNumber);
  }
  return 0;
}

void
change_video_qos()
{
  /* no-op */
}

